apiVersion: networking.k8s.io/v1
kind: NetworkPolicy
metadata:
  name: {{ .Chart.Name }}-network-policy
  namespace: {{ include "database-service.namespace" . }}
  labels:
    {{- include "database-service.labels" . | nindent 4 }}
    app.kubernetes.io/component: {{ .Chart.Name }}
spec:
  podSelector:
    matchLabels:
      app.kubernetes.io/component: {{ .Chart.Name | quote }}
  policyTypes:
    - Ingress
    - Egress
  ingress:
    - from:
        - namespaceSelector: { }  # Add empty namespaceSelector so that ingress controller from other namespace can reach the controller
          podSelector:
            matchLabels:
              app.kubernetes.io/name: {{ include "ingress.class.name" . }}
    - from:
        - podSelector:
            matchLabels:
              app.kubernetes.io/name: transaction-service
    - from:
        - podSelector:
            matchLabels:
              app.kubernetes.io/name: credential-service
    - from:
        - podSelector:
            matchLabels:
              app.kubernetes.io/name: app-service
  egress:
    - to:
        - podSelector:
            matchLabels:
              app.kubernetes.io/name: app-service
    - to:
        - podSelector:
            matchLabels:
              app.kubernetes.io/name: transaction-service
    - to:
        - podSelector:
            matchLabels:
              app.kubernetes.io/name: credential-service
    - to:
        - namespaceSelector:
            matchLabels:
              kubernetes.io/metadata.name: transaction-plane
          podSelector:
            matchLabels:
              app.kubernetes.io/name: postgresql
      ports:
        - protocol: TCP
          port: 5432
    - to:
        - namespaceSelector:
            matchLabels:
              kubernetes.io/metadata.name: base
          podSelector:
            matchLabels:
              app.kubernetes.io/name: keycloakx
      ports:
        - protocol: TCP
          port: 8443
    - to:
        - namespaceSelector:
            matchLabels:
              kubernetes.io/metadata.name: base
          podSelector:
            matchLabels:
              app.kubernetes.io/name: opentelemetry-collector
      ports:
        - port: 4317
